# Riju

Riju is a very fast online playground for every programming language.
In less than a second, you can start playing with a Python interpreter
or compiling [INTERCAL](https://en.wikipedia.org/wiki/INTERCAL) code.

Check it out at <https://riju.codes>!

Service uptime available at <https://radian.statuspage.io/>.

## Is it free?

Riju will always be free for everyone. I pay for the hosting costs out
of the business account of Radian LLC, which is funded by donations
and my personal savings. If you would like to help keep Riju online
and see more projects like it, there are a few donation methods
available in the "Sponsor this project" sidebar on GitHub.

All financial records for Radian LLC are made [publicly
available](https://github.com/radian-software/financials).

## Is it safe?

Riju does not collect your personal information.

* Your code is deleted from the server as soon as you close Riju.
* Your terminal input and output is never saved or logged anywhere.
* Riju uses [Fathom Analytics](https://usefathom.com/) to measure
  traffic. Fathom collects very limited data and does not sell it to
  third parties, unlike Google Analytics.
* Riju does not serve advertisements or share data with any third
  party aside from Fathom Analytics.

All of the above notwithstanding, any service that allows people to
run code online is inherently risky. For this reason, I can't make any
guarantees about the security or privacy of your data.

See also [Reporting a security issue](SECURITY.md).

## Are there rules?

Yes, there is one rule and it is "please be nice". Examples of not
being nice include:

* *Trying to consume as many resources as possible.* All this will do
  is prevent others from using Riju, which isn't nice.
* *Mining cryptocurrency.* Since hosting Riju comes out of ~my
  paycheck~ community donations, this is exactly equivalent to
  stealing, which isn't nice.

## Can I help? / Documentation

Absolutely, please see [Contributing guide](CONTRIBUTING.md).

## Similar projects

* [TryItOnline](https://tio.run/)
* [RyuGod](https://www.ryugod.com/)

## Acknowledgements

* A big thank you to [Mike Diarmid](https://github.com/Salakar) of
  [Invertase](https://github.com/invertase) for being an early sponsor
  of the project and helping out with hosting costs! Thanks to Mike's
  generous support I have the runway to get Riju stable enough for
  everyone to use.
* Thank you to the maintainers of
  [Monaco](https://github.com/microsoft/monaco-editor),
  [node-pty](https://github.com/microsoft/node-pty), and
  [Xterm.js](https://github.com/xtermjs/xterm.js/)! Without any one of
  these open-source libraries, version 1.0 of Riju could not have come
  to life!
